#!/bin/bash
rm -rf filters
mkdir filters

clang -c common/utils/winapi_mapping.c -o winapi_mapping.o

clang++ -Wl,-rpath,. -fPIC -shared -o libsentiero.so -DDRUN_AS_DEBUG -std=c++17 -lm -lstdc++fs -Icommon tools/sentiero/src/execute_model.cpp common/iface/DeviceIface.cpp common/rtl/DeviceLib.cpp common/rtl/FilterLib.cpp common/rtl/ReferencedImpl.cpp common/utils/string_utils.cpp common/rtl/scgmsLib.cpp common/rtl/Dynamic_Library.cpp winapi_mapping.o

clang++ -Wl,-rpath,. -o test_sentiero -DDRUN_AS_DEBUG -std=c++17 -lm -lstdc++fs -Icommon tools/sentiero/src/execute_model.cpp common/iface/DeviceIface.cpp common/rtl/DeviceLib.cpp common/rtl/FilterLib.cpp common/rtl/ReferencedImpl.cpp common/utils/string_utils.cpp common/rtl/scgmsLib.cpp common/rtl/Dynamic_Library.cpp winapi_mapping.o

clang++ -Wl,-rpath,. -fPIC -shared -o libscgms.dylib -std=c++17 -lstdc++fs -lm -Icommon common/rtl/SolverLib.cpp common/rtl/rattime.cpp common/rtl/FilesystemLib.cpp common/utils/ConvertUTF.cpp common/lang/dstrings.cpp common/iface/DeviceIface.cpp common/rtl/DeviceLib.cpp common/rtl/FilterLib.cpp common/rtl/ReferencedImpl.cpp common/utils/string_utils.cpp common/rtl/scgmsLib.cpp common/rtl/Dynamic_Library.cpp winapi_mapping.o core/scgms/src/composite_filter.cpp  core/scgms/src/configuration_link.cpp  core/scgms/src/device_event.cpp core/scgms/src/executor.cpp core/scgms/src/filter_configuration_executor.cpp core/scgms/src/filter_parameter.cpp core/scgms/src/filters.cpp core/scgms/src/fitness.cpp core/scgms/src/parameters_optimizer.cpp core/scgms/src/persistent_chain_configuration.cpp core/scgms/src/simple_bindings.cpp

#git clone https://gitlab.com/libeigen/eigen.git eigen
clang++ -Wl,-rpath,. -fPIC -shared -o ./filters/libmodel.dylib -std=c++17 -lm -lstdc++fs -Icommon -Ieigen common/rtl/SolverLib.cpp common/rtl/rattime.cpp common/rtl/FilesystemLib.cpp common/utils/ConvertUTF.cpp common/lang/dstrings.cpp common/iface/DeviceIface.cpp common/rtl/DeviceLib.cpp common/rtl/FilterLib.cpp common/rtl/ReferencedImpl.cpp common/utils/string_utils.cpp common/rtl/scgmsLib.cpp common/rtl/Dynamic_Library.cpp winapi_mapping.o core/model/src/common/uptake_accumulator.cpp core/model/src/descriptor.cpp core/model/src/bergman/bergman.cpp core/model/src/uva_padova/uva_padova.cpp core/model/src/factory.cpp core/model/src/constant/Constant_Model.cpp core/model/src/diffusion/Diffusion_Prediction.cpp core/model/src/diffusion/Diffusion_v2_blood.cpp core/model/src/diffusion/Diffusion_v2_ist.cpp core/model/src/ge/ge.cpp core/model/src/neural_net/const_neural_net.cpp core/model/src/pattern_prediction/pattern_prediction.cpp core/model/src/sensitivity/sensitivity.cpp common/utils/DebugHelper.cpp common/rtl/Common_Calculated_Signal.cpp core/model/src/steil_rebrin/Steil_Rebrin_blood.cpp core/model/src/steil_rebrin/Steil_Rebrin_Diffusion_Prediction.cpp core/model/src/bolus/insulin_bolus.cpp 

clang++ -Wl,-rpath,. -fPIC -shared -o ./filters/libsignal.dylib -std=c++17 -lm -lstdc++fs -Icommon -Ieigen common/rtl/SolverLib.cpp common/rtl/rattime.cpp common/rtl/FilesystemLib.cpp common/rtl/UILib.cpp common/rtl/ApproxLib.cpp common/utils/math_utils.cpp  common/utils/ConvertUTF.cpp common/lang/dstrings.cpp common/iface/DeviceIface.cpp common/rtl/DeviceLib.cpp common/rtl/FilterLib.cpp common/rtl/ReferencedImpl.cpp common/utils/string_utils.cpp common/rtl/scgmsLib.cpp common/rtl/Dynamic_Library.cpp winapi_mapping.o core/signal/src/expression/expression.tab.cpp core/signal/src/descriptor.cpp core/signal/src/calculated_signal.cpp core/signal/src/decoupling.cpp core/signal/src/mapping.cpp core/signal/src/masking.cpp core/signal/src/Measured_Signal.cpp core/signal/src/Signal_Feedback.cpp core/signal/src/signal_generator.cpp core/signal/src/time_segment.cpp 

rm winapi_mapping.o

# zip -r libsentiero.zip .
